#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "graphics.h"

char pcxpal[768];
char obj[64000], back[64000];
char backmap[256][256], objmap[256][256];
char vscreen[64000];
char *screen=(char*)0xa0000;
char font[7776];

void waitretrace()
{ while(inp(0x3da)&8);
  while(!(inp(0x3da)&8));
}

void setpal(char *pal)
{ int i;

  outp(0x3c8, 0);
  for(i=0; i<768; i++)
    outp(0x3c9, pal[i]);
}

char loadpcx(char *pcx, char *s)
{ FILE *f;
  unsigned int n=0,i;
  unsigned char c;

  f=fopen(s,"rb");
  fseek(f,128,SEEK_SET);
  for(n=0; n<64000;)
  { fread(&c,1,1,f);
    if(c<192) pcx[n++]=c;
    else
    { i=c-192;
      fread(&c,1,1,f);
      for(; i>0; i--)
        pcx[n++]=c;
    }
  }
  fseek(f,-768,SEEK_END);
  fread(pcxpal,768,1,f);
  for(i=0; i<768; i++) pcxpal[i]>>=2;
  fclose(f);

  return 0;
}

void displaytext(char *scr, int x, int y, char *s)
{               
  int i,j,k;

  for(i=0; i<strlen(s); i++)
  {
    for(j=0; j<8; j++)
      for(k=0; k<8; k++)
        if(font[(s[i]-32)*81+j*9+k])
          scr[(k+y)*320+x+j]=192;
    x+=8;
  }
}

void blittile(char *dest, char *src, int number, int x, int y)
{ int i;
  char *psrc, *pdest;
  int xend=16, yend=16;

  if(x<-15 || x>319 || y<-15 || y>199) return;

  psrc=src+number%20*16+number/20*320*16;
  pdest=dest+x+y*320;

  if(x<0) xend+=x, psrc-=x, pdest-=x;
  if(x+16>319) xend-=x+16-319;
  if(y<0) yend+=y, psrc-=y*320, pdest-=y*320;
  if(y+16>199) yend-=y+16-199;

  for(i=0; i<yend; i++)
  { memcpy(pdest, psrc, xend);
    psrc+=320;
    pdest+=320;
  }
}

void blittranstile(char *dest, char *src, int number, int x, int y)
{ int i, j;
  char *psrc, *pdest;
  int xend=16, yend=16;

  if(x<-15 || x>319 || y<-15 || y>199) return;

  psrc=src+number%20*16+number/20*320*16;
  pdest=dest+x+y*320;

  if(x<0) xend+=x, psrc-=x, pdest-=x;
  if(x+16>319) xend-=x+16-319;
  if(y<0) yend+=y, psrc-=y*320, pdest-=y*320;
  if(y+16>199) yend-=y+16-199;

  for(i=0; i<yend; i++)
  { for(j=0; j<xend; j++, pdest++, psrc++)
      if(*psrc) *pdest=*psrc;
    psrc+=320-xend;
    pdest+=320-xend;
  }
}

void drawscreen(char *scr, int x, int y)
{ int i, j;

  for(i=0; i<256; i++)
    if(i*16-x>-15 && i*16-x<319)
      for(j=0; j<256; j++)
        if(j*16-y>-15 && j*16-y<199)
          blittile(scr, back, backmap[i][j], i*16-x, j*16-y);
}

void drawobjscreen(char *scr, int x, int y)
{ int i, j;

  for(i=0; i<256; i++)
    for(j=0; j<256; j++)
      if(i*16-x>-15 && i*16-x<319 && j*16-y>-15 && j*16-y<199)
        blittranstile(scr, obj, objmap[i][j], i*16-x, j*16-y);
}