#include "graphics.h"
#include "tile.h"

atile animatedtiles[1024];
int nanimatedtiles=0;

void findanimatedtiles()
{ int i, j;

  for(i=0; i<256; i++)
    for(j=0; j<256; j++)
    { if(backmap[i][j]==WATER_SURFACE)
      { animatedtiles[nanimatedtiles].x=i;
        animatedtiles[nanimatedtiles].y=j;
        animatedtiles[nanimatedtiles].delay=20;
        animatedtiles[nanimatedtiles].edgedelay=20;
        animatedtiles[nanimatedtiles].frac=0;
        animatedtiles[nanimatedtiles].start=10;
        animatedtiles[nanimatedtiles].end=12;
        if(!(i%4))
        { backmap[i][j]=11;
          animatedtiles[nanimatedtiles].dir=-1;
        }
        else
        { backmap[i][j]=i%4+9;
          animatedtiles[nanimatedtiles].dir=1;
        }
        animatedtiles[nanimatedtiles].loop=PINGPONG;
        nanimatedtiles++;
      }
      if(backmap[i][j]>=BLINK_BRICK && backmap[i][j]<=BLINK_BRICK+4) 
      { animatedtiles[nanimatedtiles].x=i;
        animatedtiles[nanimatedtiles].y=j;
        animatedtiles[nanimatedtiles].delay=20;
        animatedtiles[nanimatedtiles].start=BLINK_BRICK;
        animatedtiles[nanimatedtiles].end=BLINK_BRICK+4;
        animatedtiles[nanimatedtiles].edgedelay=100;
        animatedtiles[nanimatedtiles].loop=PINGPONG;
        animatedtiles[nanimatedtiles].frac=0;
        if(backmap[i][j]==BLINK_BRICK+1)
        { animatedtiles[nanimatedtiles].frac=50;
          backmap[i][j]=BLINK_BRICK;
        }
        else if(backmap[i][j]==BLINK_BRICK+2)
        { animatedtiles[nanimatedtiles].frac=0;
          backmap[i][j]=BLINK_BRICK+1;
        }
        else if(backmap[i][j]==BLINK_BRICK+3)
        { animatedtiles[nanimatedtiles].frac=0;
          backmap[i][j]=BLINK_BRICK+4;
        }
        else if(backmap[i][j]==BLINK_BRICK+4)
          animatedtiles[nanimatedtiles].frac=50;
        animatedtiles[nanimatedtiles].dir=1;
        nanimatedtiles++;
      }

    }
}

void animatetile(atile *t)
{ t->frac++;
  if(backmap[t->x][t->y]!=t->start && backmap[t->x][t->y]!=t->end)
  { if(t->frac<t->delay) return;
  }
  else if(t->frac<t->edgedelay) return;
  backmap[t->x][t->y]+=t->dir;
  if(t->loop==PINGPONG)
  { if(backmap[t->x][t->y]>t->end) backmap[t->x][t->y]=t->end-1, t->dir=-1;
    if(backmap[t->x][t->y]<t->start) backmap[t->x][t->y]=t->start+1, t->dir=1;
  }
  else
  { if(backmap[t->x][t->y]>t->end) backmap[t->x][t->y]=t->start;
    if(backmap[t->x][t->y]<t->start) backmap[t->x][t->y]=t->end;
  }
  t->frac=0;
}