typedef struct
{ int type;
  long *data;
  char remove;
  int (*blocking)();
  void (*blit)();
  void (*advframe)();
} object;

extern object objlist[4096];
extern int nobj;

#define PLAYER 20
#define BLOB 40
#define COIN 60
#define SPIKE 80
#define GREENKEY 100
#define REDKEY 101
#define BLUEKEY 102
#define GREENLOCK 103
#define REDLOCK 104
#define BLUELOCK 105
#define BREAKER 120
#define MOVINGPLAT 140
#define SPRINGBOARD 160
#define PORTCULLIS 180

int blocks(int tile);
int blocked(int x, int y);
void *zcalloc(int a, int b);
void createobject(int type, int x, int y);
void removeobjects();